﻿namespace WorkerRole1

open System
open System.Collections.Generic
open System.Diagnostics
open System.Linq
open System.Net
open System.Threading
open Microsoft.WindowsAzure
open Microsoft.WindowsAzure.Diagnostics
open Microsoft.WindowsAzure.ServiceRuntime
open Microsoft.WindowsAzure.StorageClient

type WorkerRole() =
    inherit RoleEntryPoint() 

    // This is a sample worker implementation. Replace with your logic.
    let log message kind = Trace.WriteLine(message, kind)    

    override wr.Run() =

        log "WorkerRole1 entry point called" "Information"

        let connectionStringName = "MyConnectionString"
        let storageAccount = CloudStorageAccount.Parse(CloudConfigurationManager.GetSetting(connectionStringName))
        let queueClient = storageAccount.CreateCloudQueueClient()
        let queue = queueClient.GetQueueReference("myqueue")

        ignore <| queue.CreateIfNotExist()
        let mutable sleepTime = 1000
        while(true) do 
            Thread.Sleep(sleepTime)
                    
            let message = CloudQueueMessage("Hello, World")
            queue.AddMessage(message)
            log "add new message" "Information"

            let queueSize = queue.RetrieveApproximateMessageCount()
            sleepTime <- if queueSize>3 then 
                                sleepTime + 100
                            else
                                max (sleepTime / 2) 1

            let msg = sprintf "Current Sleep time is %A" sleepTime
            log msg "Information"

    override wr.OnStart() = 

        // Set the maximum number of concurrent connections 
        ServicePointManager.DefaultConnectionLimit <- 12
       
        // For information on handling configuration changes
        // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.

        base.OnStart()
