﻿module Code11

/// Listing 1-54
let mySeq = { 1..5 }
let myList = [ 1.. 5 ]
let myArray = [| 1..5 |]

// convert from list to a seq
let mySeqFromList = myList |> Seq.ofList

// convert from an array to a seq
let mySeqFromArray = myArray |> Seq.ofArray

// convert from a seq to a list
let myListFromSeq = mySeq |> List.ofSeq

// convert from an array to a list
let myListFromArray = myArray |> List.ofArray

// convert from a seq to an array
let myArrayFromSeq = mySeq |> Array.ofSeq

// convert from a list to an array
let myArrayFromList = myList |> Array.ofList

/// Listing 1-56
[<Literal>]
let upperLimit = 100

seq { 0..upperLimit }                //given data from 0 to 100
|> Seq.filter (fun n -> n % 2 <> 0)      //data subset contains only odd numbers
|> Seq.sum                                  //sum them up
|> printfn "the sum of odd number from 0 to 100 is %A"  //print out the result

/// Listing 1-57, 58
type Card = 
    |  Jack = 11
    |  Queen = 12
    |  King = 13
    |  Ace = 14

type OptionEnum = 
    | DefaultOption = 0b0000
    | Option1 = 0b0001
    | Option2 = 0b0010
    | Option3 = 0b0100
    | Option4 = 0b1000

let option1 = OptionEnum.Option1
let opton1Value = int OptionEnum.Option1    //option1 value is integer 1

/// Listing 1-60
type EvenOddFlagEnum = 
    |  Odd = 0x1
    |  Even = 0x0

seq { 0..100 }                             //given data from 0 to 100
|> Seq.filter (fun n -> n &&& (int EvenOddFlagEnum.Odd) <> 0 ) //data subset contains only odd numbers
|> Seq.sum                               //sum them up
|> printfn "the sum of odd numbers from 0 to 100 is %A"   //print out the result

/// Listing 1-63
// define tuple without parentheses
let a = 1, 2
let b = 1, "two"

// get first element in a tuple
let isOne = fst a

// get second element in a tuple
let isTwo = snd b

/// Listing 1-64
// get the third value of the triple
let third (_,_,c) = c

// get the fourth value of the quadruple
let fourth (_,_,_,d) = d

third (1,2,3) // return 3
fourth (1,2,3,4) //return 4


/// Listing 1-65
let l = [(1,2,3); (2,3,4); (3,4,5)]
for a,b,c in l do
    printfn "triple is (%d,%d,%d)" a b c

