﻿module Code12

/// Listing 1-67
// define an enum
type EvenOddFlagEnum = 
           |  Odd = 0x1
           |  Even = 0x0

// define a function to check if the given number is odd or not
let checkOdd n = n &&& (int EvenOddFlagEnum.Odd) <> 0

seq { 0..100 }                          //given data from 0 to 100
|> Seq.filter checkOdd                //data subset contains only odd numbers
|> Seq.sum                               //sum them up
|> printfn "the sum of odd number from 0 to 100 is %A"   //print out the result

/// Listing 1-70
let f0 x = x * 2
let f1 x = x + 7

//composite f and g to get a new function
// g(x) = x + 11
// the f0 function is executed first and then f1
let g = f0 >> f1

// result is 2 * 2 + 7 = 11
let result = g 2

///Listing 1-73
let input = [ 1..10 ]

// assign String.Join to join with the string*string list as function signature
let join : string*string list -> string = System.String.Join

// convert join to curry format
let curryFormatJoin = FuncConvert.FuncFromTupled join

input
|> List.map (fun number -> string(number))  //convert int to string
|> curryFormatJoin "*"      // join the string list to a string string using "*"


