﻿module Code6

/// Listing 1-34
let mySeq = seq { 1..10 }
let mySeq2 = seq { 10..-1..1 }

// check if mySeq contains 3, which will make "fun n -> n = 3" return TRUE
if mySeq |> Seq.exists (fun n -> n = 3) then printfn "mySeq contains 3"

// more concise version to check if it contains number 3
if mySeq |> Seq.exists ((=) 3) then printfn "mySeq contains 3"

// check if two sequences contain the same element at the same location
if Seq.exists2 (fun n1 n2 -> n1 = n2) mySeq mySeq2 then printfn "two sequences contain same element"

/// Listing 1-37, 38
let myEvenNumberSeq = { 2..2..10 }

// check if all of the elements in the seq are even 
myEvenNumberSeq |> Seq.forall (fun n -> n % 2 = 0)

let myEvenNumberSeq2 = { 12..2..20 }

if Seq.forall2 (fun n n2 -> n + 10 = n2) myEvenNumberSeq myEvenNumberSeq2 then printfn "forall2 returns TRUE"

/// Listing 1-39
let isDivisibleBy number elem = elem % number = 0
let result = Seq.find (fun n -> isDivisibleBy 5 n)[ 1 .. 100 ]
printfn "%d " result    //result is 5
