﻿module Code2_52

// generic type with NULL constraint
type MyClass<'T when 'T : null> () = class 
    let a:'T = Unchecked.defaultof<'T>
end 

// string array that can have NULL as a proper value
let b = MyClass<string ``[]``>()

// string sequence that can have NULL as a proper value
let b3 = MyClass<string seq>()

// string list that CANNOT have NULL as a proper value
// let b2 = MyClass<string list>()

type MyRecord = { X : int; Y : string }
// record that CANNOT have NULL as a proper value
// let b4 = MyClass<MyRecord>()

// use .NET tuple as a constraint that can take NULL
let b5 = MyClass< System.Tuple<string,string> >()

// string*string tuple CANNOT have NULL
// let b6 = MyClass< string*string > ()

// function int->int CANNOT have NULL
// let b7 = MyClass< int->int > ()

type MyClass2() = class
    
  end

// class MyClass2 cannot be NULL
//let b8 = MyClass< MyClass2 >()
