﻿module Code

let A = [0; 2; 4; 5; 6; 8; 9]
let B = [1; 3; 5; 7; 8]

query {
        for a in A do 
        for b in B do 
        where (a < b)
        select (a, b)
} 
|> Seq.iter(fun (n, e) -> printfn "%d is less than %d" n e)


open System
open System.Linq
open Microsoft.FSharp.Linq.NullableOperators

type Student() = 
    member val ID = 0 with get, set
    member val Name = "" with get, set
    member val Age = Nullable(0) with get, set

let showResult query = query |> Seq.iter (printfn "%A")

let studentTable = [ 
        Student(ID = 1, Name = "Anita", Age = Nullable(22));
        Student(ID = 1, Name = "Kate", Age = Nullable(22))
        Student(ID = 1, Name = "Brent", Age = Nullable(23))
        Student(ID = 1, Name = "Lisa", Age = Nullable(23))  
        Student(ID = 1, Name = "Mark", Age = Nullable(24)) ].AsQueryable()

// take the last student
let internal q15 = query {
    for student in studentTable do
    select student.Name
    last }

showResult [ q15 ]

/// Listing 4-47

// define a function taking 3 parameters in curried format
let f3 a b c = a + b + c + 1 

// define a function taking 2 parameters in curried format 
let f2 a b = a + b + 1

// define a function taking a parameter
let f a = a + 1

let print x = printfn "value = %A" x

print ( (1, 2, 3) |||> f3 )
print ( (1, 2) ||> f2 )
print ( 1 |> f )

print ( f3 <||| (1, 2, 3) )
print ( f2 <|| (1, 2) )
print ( f <| 1 )


// Listing 4-53
open System.Runtime.Serialization.Json
open System.Runtime.Serialization 

let serializeAndDeserialize (originalValue:'T) = 

    // Create a serializer to serialize the data 
    let serializer = DataContractJsonSerializer(typeof<'T>)
    use out = new System.IO.MemoryStream()
    printfn "input data is %A" originalValue
    serializer.WriteObject(out, originalValue)

    // Get the serialized text
    let text = out.ToArray() |> System.Text.Encoding.UTF8.GetString
    out.Seek(0L, System.IO.SeekOrigin.Begin) |> ignore
    printfn "serialized data as: %s" text

    let deserializedValue = serializer.ReadObject out
    printfn "deserialized the data as: %A" deserializedValue

serializeAndDeserialize (1,2)
