﻿module Code7_10

open System

// merge two list into one list
let rec merge list0 list1 = 
    match list0, list1 with 
    | [], [] -> []
    | [], list
    | list, [] -> list
    | h0::t0, h1::t1 -> 
        if h0 < h1 then
            [h0] @ merge t0 list1
        else
            [h1] @ merge list0 t1

// merge sort algorithm function
let rec mergeSort list = 
    match list with
    | [] -> []
    | [a] -> [a]
    | [a; b] -> [ min a b; max a b ]
    | _ -> 
        let firstHalf = 
            list 
            |> Seq.take (list.Length / 2)
            |> Seq.toList
        let secondHalf = 
            list
            |> Seq.skip (list.Length / 2)
            |> Seq.toList

        let sortedFirstHalf = mergeSort firstHalf
        let sortedSecondHalf = mergeSort secondHalf

        merge sortedFirstHalf sortedSecondHalf

mergeSort [1;3;9;2;4;7;6;5]
