﻿module Code7_16

type CompareResult = 
    | Higher
    | Lower
    | Middle

let compare = function
    | low,current,_ when current <= low -> Lower
    | _, current,high when current >= high -> Higher
    | _ -> Middle

let dutchFlag (list: _ array) (low, high) = 
    let swap (i,j) = 
        let temp = list.[i]
        list.[i] <- list.[j]
        list.[j] <- temp

    let mutable i = 0
    let mutable lowPointer = 0
    let mutable highPointer = list.Length - 1

    while i<highPointer do
        let value = low, list.[i], high
        match compare value with
        | Lower -> 
            swap (lowPointer, i)
            lowPointer <- lowPointer + 1
            i <- i + 1
        | Higher ->
            swap (highPointer, i)
            highPointer <- highPointer - 1
        | Middle -> 
            i <- i + 1

let arr = [| 1; 9; 8; 2; 4; 3; 6; 7; 5; 0; |]
dutchFlag arr (3, 7) 
