﻿module Code7_19

type NodeType = int

// DU definition for a tree structure
type Tree =
    | Node of NodeType * Tree list

let createTree() = 
    Node(1, [ Node(2, [Node(4, []); 
                       Node(5, [])
                      ]);
              Node(3, [Node(6, []);
                       Node(7, [Node(9,[])]);
                       Node(8, [])
                      ])
            ])

let rec preOrder visit tree = 
    match tree with
        | Node(value, children) -> 
            visit value
            children
            |> Seq.iter (preOrder visit)

let rec postOrder visit tree = 
    match tree with
        | Node(value, children) ->             
            children
            |> Seq.iter (postOrder visit)
            visit value

let mutable result = []
let sum v = 
    result <- result @ [v]
preOrder sum (createTree())

result <- []
postOrder sum (createTree())
