﻿module Code7_23

type NodeType = int

type BinaryTree = 
    | Nil 
    | Node of NodeType * BinaryTree * BinaryTree

let createBinaryTree() = 
    Node(6, Node(4, Node(2, 
                            Node(1, Nil, Nil), 
                            Node(3, Nil, Nil)), 
                    Node(5,  Nil, Nil)),
            Node(7, 
                    Nil,
                    Node(9, Nil, Nil))
        )

let rec checkInOrder value list = 
    match list with
    | [] -> true
    | head::tail -> 
        if value<head then
            checkInOrder head tail
        else
            false

let rec inOrder visit tree = 
    match tree with
        | Nil -> ()
        | Node(v, left, right) -> 
            inOrder visit left
            visit v
            inOrder visit right

let mutable result = []
let sum v = 
    result <- result @ [v]

inOrder sum (createBinaryTree())

checkInOrder System.Int32.MinValue result
