﻿module Code7_29

type NodeType = int

type BinaryTree = 
    | Nil 
    | Node of NodeType * BinaryTree * BinaryTree

let createBinaryTree() = 
    Node(1, Node(2, Node(4, Nil, Nil), 
                    Node(5, 
                            Node(6, Nil, Nil), 
                            Node(7, Nil, Nil))),
            Node(3, 
                    Nil,
                    Node(8, 
                            Nil, 
                            Node(9, Nil, Nil)))
        )

let rec treeHeight tree =
    match tree with
    | Nil -> 0
    | Node(v, left, right) -> 
        let leftHeight = treeHeight left
        let rightHeight = treeHeight right
        (max leftHeight rightHeight) + 1

let rec treeDiameter tree = 
    match tree with 
    | Nil -> 0
    | Node(v, left, right) ->
        let leftHeight = treeHeight left
        let rightHeight = treeHeight right
        let leftDiameter = treeDiameter left
        let rightDiameter = treeDiameter right
        max (leftHeight + rightHeight + 1)
            (max leftDiameter rightDiameter)

treeDiameter (createBinaryTree())
