﻿module Code7_30

type NodeType = int

type BinaryTree = 
    | Nil 
    | Node of NodeType * BinaryTree * BinaryTree

let createBinaryTree() = 
    Node(1, Node(2, Node(4, Nil, Nil), 
                    Node(5, 
                            Node(6, Nil, Nil), 
                            Node(7, Nil, Nil))),
            Node(3, 
                    Nil,
                    Node(8, 
                            Nil, 
                            Node(9, Nil, Nil)))
        )

let findLCA (node0, node1) root = 
    let rec commonAncestor (node0, node1) root = 
        match root with
        | Nil -> None
        | Node(v, left, right) -> 
            match left, right with
            | Nil, Nil -> None
            | Node(v, _, _), _ when v = node0 || v = node1 -> Some root
            | _, Node(v, _, _) when v = node0 || v = node1 -> Some root
            | _ -> 
                let l = left |> commonAncestor (node0, node1) 
                let r = right |> commonAncestor (node0, node1) 
                match l, r with 
                | None, None -> None
                | Some(_), Some(_) -> Some root
                | Some(_) as n, None -> n
                | None, (Some(_) as n) -> n

    match root with
    | Nil -> None
    | Node(v, left, right) when v=node0 || v=node1 -> Some root
    | Node(v, left, right) -> commonAncestor (node0, node1) root

let tree = createBinaryTree()
type ResultRecord = { Nodes : NodeType*NodeType; Ancestor : NodeType }
let output r pair =
    match r with
    | Some(Node(v, _, _)) -> { Nodes = pair; Ancestor = v }
    | _ -> { Nodes = pair; Ancestor = -1 }    

let pairsToFindAncestor = [
    (2, 3)
    (1, 8)
    (1, 2)
    (3, 8)
    (8, 7)
    (4, 6)
    (4, 7) ]

let r = 
    pairsToFindAncestor 
    |> List.map (fun pair -> pair, (tree |> findLCA pair))
    |> List.map (fun (pair, result) -> pair |> output result)
