﻿namespace MasterNode

open System
open System.Collections.Generic
open System.Diagnostics
open System.Linq
open System.Net
open System.Threading
open Microsoft.WindowsAzure
open Microsoft.WindowsAzure.Diagnostics
open Microsoft.WindowsAzure.ServiceRuntime
open Microsoft.WindowsAzure.StorageClient

type WorkerRole() =
    inherit RoleEntryPoint() 

    // This is a sample worker implementation. Replace with your logic.

    let log message kind = Trace.WriteLine(message, kind)
    let random = Random()

    override wr.Run() =

        let connectionStringName = "QueueConnectionString"
        let storageAccount = CloudStorageAccount.Parse(CloudConfigurationManager.GetSetting(connectionStringName))
        let queueClient = storageAccount.CreateCloudQueueClient()
        let queue = queueClient.GetQueueReference("myqueue")
        let queue2 = queueClient.GetQueueReference("resultqueue")

        ignore <| queue.CreateIfNotExist()
        ignore <| queue2.CreateIfNotExist()

        let data = [| 1..100 |]

        let chunk = 9
        // insert 10 elements
        [0..chunk]
        |> Seq.map (fun i -> i*10, (i+1)*10-1)
        |> Seq.iter (fun (a,b) -> 
                        let l = 
                            data.[a..b]
                            |> Array.map (fun i -> i.ToString())
                        
                        queue.AddMessage(CloudQueueMessage(String.Join(",", l))))

        let result = 
            [0..chunk]
            |> Seq.map (fun _ -> 
                            while queue2.PeekMessage() = null do
                                Thread.Sleep(random.Next(5,100))
                            queue2.GetMessage().AsString |> Convert.ToInt32)
            |> Seq.sum

        log (sprintf "final result = %A" result) "Information"

        log "MasterNode entry point called" "Information"
        while(true) do 
            Thread.Sleep(10000)
            log "Working" "Information"

    override wr.OnStart() = 

        // Set the maximum number of concurrent connections 
        ServicePointManager.DefaultConnectionLimit <- 12
       
        // For information on handling configuration changes
        // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.

        base.OnStart()
